<?
/*
##    -----------------------------------------------------------------
##    $Id: TableBrowser.php,v 1.3 2002/12/23 11:29:49 jonen Exp $
##    ------------------------------------------------------------------
##    $Log: TableBrowser.php,v $
##    Revision 1.3  2002/12/23 11:29:49  jonen
##    + disabled save state to session var, cause this doesn't support
##       more than one TB paging settings
##
##    Revision 1.2  2002/12/18 22:38:49  jonen
##    + added (semi-, needs rework!) paging of case 'list'
##
##    Revision 1.1  2002/12/06 04:11:58  joko
##    + initial check-in - moved here from core-lib
##
##    Revision 1.9  2002/12/05 23:15:51  cvsjoko
##    + added handler for iterating through 'list's (very normal arrays)
##
##    Revision 1.8  2002/10/09 00:43:48  cvsjoko
##    + bugfix: don't do errors if form-declaration does not exist
##
##    Revision 1.7  2002/07/04 08:06:50  cvsmax
##    + integrate 'table-browser' to gui-layout and code
##    + create 'account_betsTB.page'
##    + create 'home_account.page'
##
##    Revision 1.6  2002/07/03 14:09:51  cvsmax
##    + purged old code
##
##    Revision 1.5  2002/06/30 01:43:09  cvsjoko
##    + modified sort-order (now: up => ascending, down => descending)
##    + isOnFirstPage, isOnLastPage
##
##    Revision 1.4  2002/06/29 23:59:40  cvsjoko
##    + conversion to unix
##
##    Revision 1.3  2002/06/29 23:55:32  cvsjoko
##    + column-sorting
##
##    Revision 1.2  2002/06/29 08:31:55  cvsjoko
##    + paging
##
##    Revision 1.1  2002/06/29 02:53:37  cvsjoko
##    no message
##
##
##    ------------------------------------------------------------------
*/

// to be used in two different cases:
// - iterating through db-resultsets
// - iterating through form-definitions

class TableBrowser {
  
  // identification (for storing data to session-variable)
  var $ident;
  
  // current status of TableEditor
  var $status;

  // (temporary) buffer
  var $buffer;
  
  function TableBrowser( $ident, $args = array() )  {

    // register session-var, if not yet done
    global $table_state;
    // TODO: if save state in session, each TableBrowser 'MUST' have 
    //           its own session-var to support more than one TB at session
    //if (!session_is_registered('table_state')) {
    //  session_register('table_state');
    //}

    // store ident to object-variable
    $this->ident = $ident;
    // store given args to object-variables
    foreach($args as $key => $value) {
      $this->$key = $value;
    }
    // mixin args to object-variables
    if ($args[mixin]) {
      foreach($args[mixin] as $key => $value) {
        $this->$key = $value;
      }
    }
    
    // store paging-info to session
    if ($this->reset || !$table_state[$this->ident][paging]) {
      $table_state[$this->ident][paging] = $this->paging;
    }
    // store sorting-info to session
    if ($this->reset || !$table_state[$this->ident][sorting]) {
      $table_state[$this->ident][sorting] = $this->sorting;
    }
    
    // modify paging-vars with control-vars
    $control_paging = $_GET[t];
    if ($control_paging) {
      $pagenumber = $table_state[$this->ident][paging][page];
      $pagenumber_max = $table_state[$this->ident][paging][pagemax];
      switch ($control_paging) {
        case 'pl':
        if ($pagenumber > 0) { $pagenumber--; }
        break;
        case 'pr':
        if ($pagenumber_max && ($pagenumber < $pagenumber_max) ) { $pagenumber++; }
        break;
      }
      $table_state[$this->ident][paging][page] = $pagenumber;
    }
    
    // modify sorting-vars with control-vars
    $control_sorting_down = $_GET[sd];
    $control_sorting_up = $_GET[su];
    // TODO: multiple-column-sorting
    if ($control_sorting_down) {
      $table_state[$this->ident][sorting][column] = $control_sorting_down;
      $table_state[$this->ident][sorting][way] = 'down';
    }
    if ($control_sorting_up) {
      $table_state[$this->ident][sorting][column] = $control_sorting_up;
      $table_state[$this->ident][sorting][way] = 'up';
    }

  }
  

  function getContent() {
    
    global $table_state;

    # get some args from object-vars
    $callback_head = $this->head_callback;
    $callback_row = $this->row_callback;

    $paging = $table_state[$this->ident][paging];
    $sorting = $table_state[$this->ident][sorting];

	# check if result from mysql or result is abstract form definition
    switch ($this->type) {
      case 'dbtable':
      
        // get base sql-string
        $sql = $this->sqlbase;
        
        // modify sql (filters)
        if (count($this->filters)) {
          foreach($this->filters as $field => $criteria) {
            $sql .= " AND $field $criteria";
          }
          $sql .= $sql_add;
        }

        // modify sql (sorting)
        if ($sorting[enabled] && $sorting[column]) {
          switch ($sorting[way]) {
            case 'up':
              $sorting_way_sql = 'ASC';
              break;
            case 'down':
              $sorting_way_sql = 'DESC';
              break;
          }
          $sql_add = " ORDER BY $sorting[column] $sorting_way_sql";
          $sql .= $sql_add;
        }

        // modify sql (paging)
        if ($paging[enabled]) {
          // get count of rows
          $res = send_sql($sql);
          // store maxpages
          //$table_state[$this->ident][paging][pagemax] = (mysql_num_rows($res) / $this->paging[pagesize]) - 1;
          $table_state[$this->ident][paging][pagemax] = round(mysql_num_rows($res) / $this->paging[pagesize]) - 1;
          $sql_add = " LIMIT " . $paging[page] * $paging[pagesize] . ", " . $paging[pagesize] * 1;
          $sql .= $sql_add;
        }
          
        // header
        if ($this->sorting[enabled]) {
          for ($i = 0; $i <= count($this->fields); $i++) {
            $key = $this->fields[$i];
            $row[$key] = $this->captions[$i];
            $sort[$key][up][urlpart] = $this->getLinkPart('SortUp', $key);
            $sort[$key][down][urlpart] = $this->getLinkPart('SortDown', $key);
          }
          $this->buffer .= $callback_head($row, $sort) . "\n";
        }
        
        // issue sql-command
        //print $sql . "<br>";
        $res = send_sql($sql);
        // iterate through database-result
        while($row = mysql_fetch_array($res, MYSQL_ASSOC)) {
          $this->buffer .= $callback_row($row) . "\n";
        }
        break;

    case 'form_def':
        # iterate through form-definition
        if (!is_array($this->handle)) { 
          // TODO: use $this->debug!
          if ($this->debug) {
            print "missing form definition<br>";
          }
          return; 
        }
        reset($this->handle);
        while($row = current($this->handle)) {
          if (!$this->filters[keys] || in_array($row[title], $this->filters[keys])) {
            $this->buffer .= $callback_row($row) . "\n";
          }
          next($this->handle);
        }
        break;

    case 'list':
        # iterate through form-definition
        if (!is_array($this->handle)) { 
          // TODO: use $this->debug!
          if ($this->debug) {
            print "missing handle!<br>";
          }
          return; 
        }
        reset($this->handle);

        // modify sql (paging)
        if ($paging[enabled]) {
          // get count of rows
          // store maxpages
          //$table_state[$this->ident][paging][pagemax] = (mysql_num_rows($res) / $this->paging[pagesize]) - 1;
          $table_state[$this->ident][paging][pagemax] = round(count($this->handle) / $this->paging[pagesize]) - 1;
          $idx_start = $paging[page] * $paging[pagesize];
          for ($i = $idx_start; $i > 0; $i--) {
            next($this->handle);
          }
        }

        $counter = 0;
        while($row = current($this->handle)) {
          if (!$this->filters[keys] || in_array($row[title], $this->filters[keys])) {
            $this->buffer .= $callback_row($row) . "\n";
          }
          next($this->handle);
          $counter++;
          if ($paging[pagesize] == $counter) {
            break;
          }
        }
        break;

    }

    return $this->buffer;
  }
  
  function getLinkPart($key, $arg = '') {
    switch($key) {
      case 'PageLeft':
        return '&t=pl';
        break;
      case 'PageRight':
        return '&t=pr';
        break;
      case 'SortDown':
        return '&sd=' . $arg;
        break;
      case 'SortUp':
        return '&su=' . $arg;
        break;
    }
  }
  
  function needsPagingControl() {
    global $table_state;
    $paging = $table_state[$this->ident][paging];
    return $paging[enabled];
  }
  
  function isOnFirstPage() {
    global $table_state;
    //print "p: " . $table_state[$this->ident][paging][page] . "<br>";
    return ($table_state[$this->ident][paging][page] == 0);
  }
  
  function isOnLastPage() {
    global $table_state;
    //print "p: " . $table_state[$this->ident][paging][page] . "<br>";
    //print "pm: " . $table_state[$this->ident][paging][pagemax] . "<br>";
    return ($table_state[$this->ident][paging][page] == $table_state[$this->ident][paging][pagemax]);
  }

}

?>