<?
//    -----------------------------------------------------------------------------
//    $Id: helper.php,v 1.4 2002/12/22 13:29:54 jonen Exp $
//    -----------------------------------------------------------------------------
//    $Log: helper.php,v $
//    Revision 1.4  2002/12/22 13:29:54  jonen
//    + added number format helper functions:
//      + number_format_locale()
//      + is_amount()
//
//    Revision 1.3  2002/12/11 01:00:22  joko
//    + renamed function 'sai' to 'array_init'
//
//    Revision 1.2  2002/12/01 04:49:54  joko
//    + function Dumper (from function dumpVar)
//
//    Revision 1.1  2002/11/12 05:42:31  joko
//    + initial checkin
//
//    Revision 1.1  2002/10/29 19:15:57  cvsjoko
//    + new checkin
//
//    Revision 1.4  2002/10/26 18:24:54  cvsmax
//    + add note to care about UTC!
//
//    Revision 1.3  2002/10/25 12:05:30  cvsmax
//    + bugfix: some db related functions wasn`t updated to new structure, done.
//    + bugfix: reworked function validate_idle()
//
//    Revision 1.2  2002/10/17 03:37:40  cvsmax
//    - removed unused function cont_auth()
//
//    Revision 1.1  2002/10/10 02:53:55  cvsmax
//    + create new partly from old 'func_main.inc'
//
//
//    -----------------------------------------------------------------------------


function get_date_forDisplay($arg_date) {
  $date = new Date($arg_date);
  // TODO:
  // - determine this constant by asking $site->user->country, i believe we'll need some kind of mapping here
  // - or can it be integrated with TimeZone? no, it's a locale setting (localization/preferences), isn't it?
  return $date->getDate( DATE_FORMAT_GERMAN_SHORT );
}

function get_date_forStorage($arg_date) {

  // was:
  //$unixtime = mktime(0, 0, 0, $arg_date[1], $arg_date[0], $arg_date[2]);
  //return date("Y-m-d", $unixtime);       // english format

  // if $arg_date is an array, it is in "german"-format (really in locale format, isn't it?)
  // TODO: check this! (do a generic reverse-map!)
  if (is_array($arg_date)) {
    $arg_date = join('.', $arg_date);
  }
  $date = new Date($arg_date);
  $date_res = $date->getDate( DATE_FORMAT_ENGLISH_SHORT );
  return $date_res;
}

// -------------------------------------------------
// array initializer
// initializes passed variable (taken by reference) with an empty array
// does this only if it doesn't exist yet or initialization is explicitely requested ($clear = 1)
function array_init(&$var, $clear = 0) {
  if (!is_array($var) || $clear) { $var = array(); }
}
  

// format functions
function isvalidemailaddress($mail) {
  // TODO: review for regex process load
  //return ((($string = trim($string)) != '') && (($atpos = strpos($string, '@' , 1)) > 1) && (($rdotpos = strrpos($string, '.')) > ($atpos + 2)) && (strlen($string) > $rdotpos + 2));
  if( !eregi("^[a-z0-9]+([_\\.-][a-z0-9]+)*"."@([a-z0-9]+([\.-][a-z0-9]+))*$",$mail, $regs) ) {
  	return "format";
  }
  elseif( gethostbyname($regs[2]) == $regs[2] ) {
    return "host";
  }
  return "valid";
}

function dumpVar($var) {
  return Dumper($var);
}

function Dumper($var) {
  ob_start();
  print_r($var);
  $var_dump = ob_get_contents();
  ob_end_clean();
  $var_dump = str_replace("\n", "<br>", $var_dump);
  $var_dump = str_replace(" ", "&nbsp;", $var_dump);
  return $var_dump;
}

function session_register_safe($varname) {
  if (!session_is_registered($varname)) {
    session_register($varname);
    return 1;
  }
}

//------------ getMonths ---------------------
// TODO: localize!
function getMonthNames() {
   for ($i=1;$i<=12;$i++) {
     $utime = strtotime("2001-$i-24 12:00:00");
     $name = date("F",$utime);
     $months[$i] = $name;
   }
   return $months;
}

function null2nbsp_string($arg) {
  if ($arg == '') {
    $arg = '&nbsp;';
  }
  return $arg;
}

function null2nbsp_arraywalker(&$item, $key) {
    $item = null2nbsp_string($item);
}

function null2nbsp($arg) {
  if (is_array($arg)) {
    array_walk($arg, 'null2nbsp_arraywalker');
    $result = $arg;
  } else {
    $result = null2nbsp_string($arg);
  }
  return $result;
}

//------------ en- and decode Birthdate -----------
function getEncodedBirthdate($birthdate) {
  print "birthday: $birthdate<br>";
  if($birthdate) {
    $utime = strtotime($birthdate);
    print "utime: $utime<br>";
    $birthday = array ( date("d",$utime), date("m",$utime), date("Y",$utime) );
  }
  else {
    $birthday = array('', '', '1960');
  }
  return $birthday;
}

/*
function dprint($message) {
  print '<span style="font-family:Verdana,Helvetica;font-size:7pt;">';
  print $message;
  print '</span><br>';
}
*/

function number_format_storage($string) {
    $locale_info = localeconv();
    $string =  str_replace($locale_info["decimal_point"], ".",  $string);
    return $string;
}

function number_format_locale1($string) {
    $locale_info = localeconv();
    $string =  str_replace(".", $locale_info["decimal_point"],  $string);
    return $string;
}


function number_format_locale ($num, $decimals = null) {
   $locale = localeconv();
   if(!isset($decimals)) $decimals = $locale['frac_digits'];
   return number_format($num, $decimals, $locale['decimal_point'], $locale['thousands_sep']);
}


function is_amount($amount) {
  //if( (number_format_locale((string)doubleval($amount)) === number_format_locale((string)$amount)) && number_format_locale((doubleval($amount)) >number_format_locale(0)) ) {
  if( ((string)doubleval($amount) === (string)$amount) && (doubleval($amount) > 0) ) {
    return 1;
  }
}

?>